package cerebral.parallelCoordinates;

import javax.swing.JComponent;

import cerebral.ControlPanel;

public class YDisplay extends JComponent {
    
    private static final long serialVersionUID = 1L;

    private double zoom;

    private double pan;

    private double displayHeight;

    
    public YDisplay() {
        zoom = 1.0;
        pan = 0.0;
    }

    public void zoomToFit(double topVal, double bottomVal) {
        double range = Math.abs(topVal - bottomVal);
        zoom = range / displayHeight;
        pan = bottomVal / zoom;

        firePropertyChange("panAndZoom", null, null);
    }

    public double getPosition(Double val) {
        return getPosition(val.doubleValue());
    }
    
    public double getPosition(double val) {
    	double v =val; 
     	if (ControlPanel.instance().isRatioData()){
     		if (v > 0.0){
     			v= v - 1.0;
     		}else{
     			v= v+1.0;
     		}
    	}
        return -1 * v / zoom + pan;
    }

    public double screenToValue(double screen) {
    	double v =  -1* (screen-pan) * zoom;
    	if (ControlPanel.instance().isRatioData()){
    		if (v > 0.0){
     			v= v  + 1.0;
     		}else{
     			v= v - 1.0;
     		}
    	}
    	return v;
    }

    public void pan(double dy) {
        pan += dy;

        firePropertyChange("panAndZoom", null, null);

    }

    public void scale(double ds) {
        zoom *= ds;

        firePropertyChange("panAndZoom", null, null);

    }

    public void setDisplayHeight(double height) {
        displayHeight = height;
    }
    
    public double getDisplayHeight(){
        return displayHeight;
    }
}
