package cerebral.render;

import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import prefuse.render.AbstractShapeRenderer;
import prefuse.util.GraphicsLib;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class StraightEdgeRenderer extends AbstractShapeRenderer {
      protected Line2D       line  = new Line2D.Float();    
      protected Rectangle2D cursorRect = new Rectangle2D.Float();
     
      
     public StraightEdgeRenderer() {
     }


     public boolean locatePoint(Point2D p, VisualItem item) {
        cursorRect.setFrame(p.getX(), p.getY(), 4,4);
        
        line = (Line2D) getRawShape(item);
        return line.intersects(cursorRect);
       }

     public void setBounds(VisualItem item) {
        Shape shape = getRawShape(item);
        if (shape != null)
            GraphicsLib.setBounds(item, shape, getStroke(item));
     }
     protected Shape getRawShape(VisualItem item) {
         EdgeItem edge = (EdgeItem) item;
         line.setLine(0,0,0,0);
         if (edge.getSourceItem().isVisible() && edge.getTargetItem().isVisible()){
             line.setLine(edge.getSourceItem().getX(), edge.getSourceItem().getY(),
                     edge.getTargetItem().getX(),  edge.getTargetItem().getY());            
           }   
     
         
         return line;  
     }


    public void render(Graphics2D g, VisualItem item) {
        /*
         
         g.setStroke(item.getStroke());
        g.setColor(ColorLib.getColor(item.getStrokeColor()));
        g.draw(getRawShape(item));
        */
    	super.render(g, item);
    }
      
      
}
