package publicdomain;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;

import javax.swing.JPanel;
import javax.swing.Scrollable;
import javax.swing.SwingConstants;

 public class ScrollableFlowPanel extends JPanel implements Scrollable {
        private static final long serialVersionUID = 1L;
        
        public void setBounds( final int x, final int y, final int width, final int height ) {
            super.setBounds( x, y, getParent().getWidth(), height );
        }
 
        public Dimension getPreferredSize() {
            return new Dimension( getWidth(), getPreferredHeight() );
        }
 
        public Dimension getPreferredScrollableViewportSize() {
            return super.getPreferredSize();
        }
 
        public int getScrollableUnitIncrement( final Rectangle visibleRect, final int orientation, final int direction ) {
            final int hundredth = ( orientation ==  SwingConstants.VERTICAL
                    ? getParent().getHeight() : getParent().getWidth() ) / 100;
            return ( hundredth == 0 ? 1 : hundredth ); 
        }
 
        public int getScrollableBlockIncrement( final Rectangle visibleRect, final int orientation, final int direction ) {
            return orientation == SwingConstants.VERTICAL ? getParent().getHeight() : getParent().getWidth();
        }
 
        public boolean getScrollableTracksViewportWidth() {
            return true;
        }
 
        public boolean getScrollableTracksViewportHeight() {
            return false;
        }
 
        private int getPreferredHeight() {
            int rv = 0;
            for ( int k = 0, count = getComponentCount(); k < count; k++ ) {
                final Component comp = getComponent( k );
                final Rectangle r = comp.getBounds();
                final int height = r.y + r.height;
                if ( height > rv )
                    rv = height;
            }
            rv += ( (FlowLayout) getLayout() ).getVgap();
            return rv;
        }

       
    }